; ---------------------------------------------------------------------------
;
; DirectQB IMAGE SUPPORT module
;
; Part of the DirectQB Library version 1.51
; by Angelo Mottola, Enhanced Creations 1998-99
;
; ---------------------------------------------------------------------------

.MODEL medium,basic

.386

.STACK 200h

EXTRN Buffer:BYTE
EXTRN LastError:BYTE
EXTRN KeyActive:BYTE
EXTRN KeyStatus:BYTE
EXTRN FLIactive:BYTE
EXTRN FLIfile:WORD
EXTRN FLIbufSeg:WORD

EXTRN GetLayerSeg:FAR
EXTRN HookInt24:FAR
EXTRN UnhookInt24:FAR
EXTRN ReadBuffer:FAR
EXTRN WriteBuffer:FAR

FLIheaderType STRUC
  hSize       DD  ?
  hID         DW  ?
  Frames      DW  ?
  Xres        DW  ?
  Yres        DW  ?
  ColorBits   DW  ?
  Flags       DW  ?
  Speed       DW  ?
FLIheaderType ENDS

FLIframeChunkType STRUC
  fSize       DD  ?
  fID         DW  ?
  Chunks      DW  ?
  Reserved    DQ  ?
FLIframeChunkType ENDS

FLIdataChunkType STRUC
  cSize       DD  ?
  cID         DW  ?
FLIdataChunkType ENDS


.DATA
BSVheader     DB  0FDh,000h,0A0h,000h      ; BSAVE file header (for a 320x200
              DB  000h,000h,0FAh           ; pixels image) - 7 bytes
BMPheader     DB  042h,04Dh,036h,0FEh,000h,000h,000h,000h   ; BMP file header
              DB  000h,000h,036h,004h,000h,000h,028h,000h   ; (for a 320x200
              DB  000h,000h,040h,001h,000h,000h,0C8h,000h   ; pixels image,
              DB  000h,000h,001h,000h,008h,000h,000h,000h   ; uncompressed)
              DB  000h,000h,000h,0FAh,000h,000h,0CEh,00Eh   ; - 54 bytes
              DB  000h,000h,0C4h,00Eh,000h,000h,000h,000h
              DB  000h,000h,000h,000h,000h,000h
PCXheader     DB  00Ah,005h,001h,008h,000h,000h,000h,000h   ; PCX file header
              DB  03Fh,001h,0C7h,000h,040h,001h,0C8h,000h   ; (for a 320x200
              DB  000h,000h,000h,0D8h,098h,038h,078h,074h   ; pixels image,
              DB  004h,070h,06Ch,004h,0ECh,0ACh,04Ch,0F8h   ; encoded using
              DB  0C4h,080h,040h,024h,024h,024h,028h,014h   ; PCX version 3.0
              DB  0F8h,0BCh,068h,0D4h,090h,09Ch,03Ch,024h   ; specifications)
              DB  024h,074h,070h,008h,078h,074h,008h,07Ch   ; - 128 bytes
              DB  078h,008h,034h,030h,004h,0F0h,0C4h,088h
              DB  000h,001h,040h,001h,000h,000h,000h,000h
              DB  000h,000h,000h,000h,000h,000h,000h,000h
              DB  000h,000h,000h,000h,000h,000h,000h,000h
              DB  000h,000h,000h,000h,000h,000h,000h,000h
              DB  000h,000h,000h,000h,000h,000h,000h,000h
              DB  000h,000h,000h,000h,000h,000h,000h,000h
              DB  000h,000h,000h,000h,000h,000h,000h,000h
              DB  000h,000h,000h,000h,000h,000h,000h,000h
FLIheader     FLIheaderType <>             ; FLI header
FLIframeChunk FLIframeChunkType <>         ; FLI frame chunk
FLIdataChunk  FLIdataChunkType <>          ; FLI data chunk
FLIframe      DW  ?                        ; Current FLI frame
FLIchunk      DW  ?                        ; Current FLI chunk
FramePos      DD  ?                        ; Frame file position
ChunkPos      DD  ?                        ; Chunk file position
Packets       DW  ?                        ; Number of packets in a FLI chunk
CurLine       DW  ?                        ; Line pointer (FLI player)


.CODE

; ---------------------------------------------------------------------------
; Internal procedures for FLI animation handling
; ---------------------------------------------------------------------------
DecodeCOLOR PROC NEAR
  MOV AX,FS:[BX]
  ADD BX,2
  MOV Packets,AX
  XOR AH,AH         ; AH is the color index
COLORpacket:
  ADD AH,FS:[BX]
  INC BX
  MOV DX,03C8h
  MOV AL,AH
  OUT DX,AL
  XOR CH,CH
  MOV CL,FS:[BX]
  INC BX
  MOV DX,03C9h
  CMP CX,0
  JNE SetColor
  MOV CX,256
SetColor:
  MOV AL,FS:[BX]
  INC BX
  OUT DX,AL
  MOV AL,FS:[BX]
  INC BX
  OUT DX,AL
  MOV AL,FS:[BX]
  INC BX
  OUT DX,AL
  INC AH
  DEC CX
  JNZ SetColor
  DEC Packets
  JNZ COLORpacket
  RET
DecodeCOLOR ENDP


DecodeLC PROC NEAR
  MOV AX,FS:[BX]
  ADD BX,2
  MOV CurLine,AX        ; CurLine holds number of lines to skip
  MOV SI,FS:[BX]
  ADD BX,2
LCline:
  MOV DI,CurLine
  MOV AX,DI
  SHL DI,6
  SHL AX,8
  ADD DI,AX
  XOR AH,AH
  MOV AL,FS:[BX]
  INC BX
  MOV Packets,AX        ; Store number of packets of current compressed line
  OR AX,AX
  JZ NextLCline
LCpacket:
  XOR DH,DH
  MOV DL,FS:[BX]
  INC BX
  ADD DI,DX
  XOR CH,CH
  MOV CL,FS:[BX]
  INC BX
  OR CL,CL
  JS LCrep
  PUSH SI
  PUSH DS
  MOV SI,BX
  ADD BX,CX
  MOV AX,FS
  MOV DS,AX
  REP MOVSB
  POP DS
  POP SI
  JMP LCnextPacket
LCrep:
  NEG CL
  MOV AL,FS:[BX]
  INC BX
  REP STOSB
LCnextPacket:
  DEC Packets
  JNZ LCpacket
NextLCline:
  INC CurLine
  DEC SI
  JNZ LCline
  RET
DecodeLC ENDP


DecodeBRUN PROC NEAR
  MOV CurLine,0
BRUNline:
  XOR DI,DI
  ADD DI,CurLine
  XOR AH,AH
  MOV AL,FS:[BX]
  INC BX
  MOV Packets,AX
BRUNpacket:
  XOR CH,CH
  MOV CL,FS:[BX]
  INC BX
  OR CL,CL
  JS BRUNrep
  MOV AL,FS:[BX]
  INC BX
  REP STOSB
  JMP BRUNnextPacket
BRUNrep:
  NEG CL
  PUSH SI
  PUSH DS
  MOV SI,BX
  ADD BX,CX
  MOV AX,FS
  MOV DS,AX
  REP MOVSB
  POP DS
  POP SI
BRUNnextPacket:
  DEC Packets
  JNZ BRUNpacket
  ADD CurLine,320
  CMP CurLine,64000
  JNE BRUNline
  RET
DecodeBRUN ENDP


DecodeFrame PROC NEAR
  MOV BX,FLIfile
  MOV AH,03Fh
  MOV DX,OFFSET FLIframeChunk
  MOV CX,16
  INT 21h
  JC EndDecodeFrame
  CMP FLIframeChunk.fID,0F1FAh     ; If there's an unknown frame type, skip it
  JNE EndDecodeFrame
  MOV AX,FLIframeChunk.chunks
  MOV FLIchunk,AX
  MOV ChunkPos,0
DecodeChunk:
  MOV AH,03Fh
  MOV DX,OFFSET FLIdataChunk
  MOV CX,6
  MOV BX,FLIfile
  INT 21h
  JC EndDecodeFrame
  PUSH DS
  XOR DX,DX
  MOV ECX,FLIdataChunk.cSize
  SUB CX,6
  MOV AX,FLIbufSeg
  MOV DS,AX
  MOV AH,03Fh
  INT 21h
  POP DS
  JC EndDecodeFrame
  XOR BX,BX
  CMP FLIdataChunk.cID,11
  JNE NotCOLOR
  CALL DecodeCOLOR          ; COLOR chunk type
  JMP NextChunk
NotCOLOR:
  CMP FLIdataChunk.cID,12
  JNE NotLC
  CALL DecodeLC             ; LC chunk type
  JMP NextChunk
NotLC:
  CMP FLIdataChunk.cID,13
  JNE NotBLACK
  XOR DI,DI                 ; BLACK chunk type
  XOR EAX,EAX
  MOV CX,16000
  REP STOSD
  JMP NextChunk
NotBLACK:
  CMP FLIdataChunk.cID,15
  JNE NotBRUN
  CALL DecodeBRUN           ; BRUN chunk type
  JMP NextChunk
NotBRUN:
  CMP FLIdataChunk.cID,16
  JNE EndDecodeFrame
  PUSH DS                   ; COPY chunk type
  MOV AX,FLIbufSeg
  MOV DS,AX
  XOR SI,SI
  XOR DI,DI
  MOV CX,16000
  REP MOVSD
  POP DS
NextChunk:
  DEC FLIchunk
  JNZ DecodeChunk
  CLC
EndDecodeFrame:
  RET
DecodeFrame ENDP


; ---------------------------------------------------------------------------
; DQBloadLayer FUNCTION
; purpose:
;   Loads an image onto specified layer. It supports BSAVE, BMP and PCX image
;   formats, and it automatically detects which one is used by specified file.
;   When loading a BMP or a PCX, its palette is stored at specified address;
;   when loading BSAVEd images, the palette is ignored.
; declaration:
;   DECLARE FUNCTION xDQBloadLayer(BYVAL Layer,BYVAL FileSeg,BYVAL FileOff,
;                                 BYVAL PalSeg,BYVAL PalOff)
;   DECLARE FUNCTION DQBloadLayer(Layer AS INTEGER,FileName AS STRING,
;                                 Pal AS STRING)
; ---------------------------------------------------------------------------
PUBLIC xDQBloadLayer
xDQBloadLayer PROC
  ; Stack layout:
  ;
  ; 16  Layer
  ; 14  FileSeg
  ; 12  FileOff
  ; 10  PalSeg
  ; 08  PalOff
  ; 06  Basic return segment
  ; 04  Basic return offset
  ; 02  DS
  ; 00  BP
  PUSH DS
  PUSH BP
  MOV BP,SP
  CALL HookInt24
  MOV BX,[BP+16]
  CALL GetLayerSeg
  MOV ES,CX
  MOV AX,[BP+14]
  MOV DS,AX
  MOV DX,[BP+12]
  MOV AX,3D00h
  INT 21h
  JC Error_Open
  MOV BX,AX
  MOV AX,@DATA
  MOV DS,AX
  XOR AX,AX
  XOR DX,DX
  XOR SI,SI
  CLD
FindFormat:
  CALL ReadBuffer
  JC Error_Read
  MOV CL,Buffer
  CMP CL,BSVheader[SI]
  JNE NotBSV
  INC AH
NotBSV:
  CMP CL,BMPheader[SI]
  JNE NotBMP
  INC DL
NotBMP:
  CMP CL,PCXheader[SI]
  JNE NotPCX
  INC AL
NotPCX:
  INC SI
  CMP SI,7
  JL FindFormat
  CMP AH,7
  JE LoadBSV
  CMP DL,7
  JE LoadBMP
  CMP AL,7
  JE LoadPCX
  JMP Error_BadFile
LoadBMP:
  XOR SI,SI
  MOV CX,47         ; Skip remaining of BMP header
CheckBMPheader:
  CALL ReadBuffer
  JC Error_Read
  DEC CX
  JNZ CheckBMPheader
  PUSH ES
  MOV AX,[BP+10]
  MOV ES,AX
  MOV DI,[BP+8]
  MOV CX,256
LoadPalette:
  CALL ReadBuffer
  JC Error_Read
  MOV AL,Buffer
  SHR AL,2
  MOV ES:[DI+2],AL
  CALL ReadBuffer
  JC Error_Read
  MOV AL,Buffer
  SHR AL,2
  MOV ES:[DI+1],AL
  CALL ReadBuffer
  JC Error_Read
  MOV AL,Buffer
  SHR AL,2
  MOV ES:[DI],AL
  CALL ReadBuffer
  JC Error_Read
  ADD DI,3
  DEC CX
  JNZ LoadPalette
  POP ES
  MOV CX,200
LoadBMPloop:
  MOV DX,CX
  DEC DX
  MOV SI,DX
  SHL DX,8
  SHL SI,6
  ADD DX,SI
  PUSH CX
  MOV AX,ES
  MOV DS,AX
  MOV CX,320
  MOV AH,3Fh
  INT 21h
  JC Error_Read
  POP CX
  DEC CX
  JNZ LoadBMPloop
  JMP LoadCloseFile
LoadPCX:
  XOR SI,SI
  MOV CX,121        ; Skip remaining of PCX header
CheckPCXheader:
  CALL ReadBuffer
  JC Error_Read
  DEC CX
  JNZ CheckPCXheader
  XOR DI,DI
  XOR AX,AX
LoadPCXloop:
  CALL ReadBuffer
  JC Error_Read
  MOV AL,Buffer
  PUSH AX
  AND AL,0C0h
  CMP AL,0C0h
  POP AX
  JE DecodeChunk
  STOSB
  JMP NextChunk
DecodeChunk:
  SUB AL,0C0h
  PUSH AX
  CALL ReadBuffer
  JC Error_Read
  POP CX
  MOV AL,Buffer
  REP STOSB
NextChunk:
  CMP DI,0FA00h
  JB LoadPCXloop
  CALL ReadBuffer
  JC Error_Read
  MOV AX,[BP+10]
  MOV ES,AX
  MOV DI,[BP+8]
  MOV CX,768
LoadPalette1:
  CALL ReadBuffer
  JC Error_Read
  MOV AL,Buffer
  SHR AL,2
  STOSB
  DEC CX
  JNZ LoadPalette1
  JMP LoadCloseFile
LoadBSV:
  MOV AX,ES
  MOV DS,AX
  MOV CX,64000
  XOR DX,DX
  MOV AH,3Fh
  INT 21h
  JC Error_Read
  JMP LoadCloseFile
Error_Open:
  MOV AX,1          ; Error 1: Cannot open file (does it exist?)
  MOV LastError,4
  JMP EndLoadLayer
Error_Read:
  MOV AH,3Eh
  INT 21h
  MOV AX,2          ; Error 2: Unable to read from file
  MOV LastError,5
  JMP EndLoadLayer
Error_BadFile:
  MOV AH,3Eh
  INT 21h
  MOV AX,3          ; Error 3: Bad file format
  MOV LastError,11
  JMP EndLoadLayer
LoadCloseFile:
  MOV AH,3Eh
  INT 21h
  XOR AX,AX
EndLoadLayer:
  CALL UnhookInt24
  POP BP
  POP DS
  RET 10
xDQBloadLayer ENDP

; ---------------------------------------------------------------------------
; DQBsaveLayer FUNCTION
; purpose:
;   Saves specified layer to a file. Two saving methods available: the first
;   saves only the layer into a BSAVE compatible binary file, the second
;   stores the layer as a PCX file, including specified palette. The function
;   returns 0 on success, otherwise an error code.
; declaration:
;   DECLARE FUNCTION xDQBsaveLayer(BYVAL Layer,BYVAL FileSeg,BYVAL FileOff,
;                                 BYVAL PalSeg,BYVAL PalOff,BYVAL Format)
;   DECLARE FUNCTION DQBsaveLayer(Layer AS INTEGER,FileName AS STRING,
;                                 Pal AS STRING,Format AS INTEGER)
; ---------------------------------------------------------------------------
PUBLIC xDQBsaveLayer
xDQBsaveLayer PROC
  ; Stack layout:
  ;
  ; 18  Layer
  ; 16  FileSeg
  ; 14  FileOff
  ; 12  PalSeg
  ; 10  PalOff
  ; 08  Format
  ; 06  Basic return segment
  ; 04  Basic return offset
  ; 02  DS
  ; 00  BP
  PUSH DS
  PUSH BP
  MOV BP,SP
  CALL HookInt24
  MOV BX,[BP+18]
  CALL GetLayerSeg
  MOV ES,CX
  MOV DX,[BP+14]    ; DS:DX points to the asciiz filename
  MOV AX,[BP+16]
  MOV DS,AX
  MOV AH,3Ch        ; Function 3Ch: create file
  MOV CX,20h        ; archive attribute
  INT 21h
  JC Error_Create
  MOV BX,AX
  MOV AX,[BP+8]
  CMP AX,0
  JE SaveBSV
  CMP AX,1
  JE SaveBMP
  MOV DX,OFFSET PCXheader
  MOV AX,@DATA
  MOV DS,AX
  MOV CX,128        ; Let's write the PCX header at the beginning of the file
  MOV AH,40h        ; Function 40h: write to file
  INT 21h
  JC Error_Write
  XOR DI,DI         ; Let's begin with the first layer pixel
  MOV CX,200        ; Scans 200 lines
SavePCXloop:
  XOR DX,DX         ; DX holds the pixel being processed
EncodeLine:
  XOR SI,SI         ; SI holds the number of consecutive equal pixels
  PUSH BX
FindEquals:
  MOV BX,DX
  ADD BX,SI
  CMP BX,320        ; Have we reached the end of line?
  JGE WriteData      ; Yes: write data
  CMP SI,63         ; A maximum of 63 consecutive pixels is allowed
  JGE WriteData
  MOV BX,DI
  ADD BX,SI
  MOV AL,ES:[BX]
  CMP AL,ES:[BX+1]  ; Let's check if we have two equal consecutive pixels
  JNE WriteData     ; No: write a single pixel
  INC SI            ; Yes: increase the consecutive pixels counter (SI)
  JMP FindEquals
WriteData:
  CMP SI,0          ; Are there any consecutive equal pixels?
  JE SinglePixel    ; No: write a single pixel
  ADD DX,SI
  ADD DI,SI
  MOV BX,SI
  OR BL,192
  MOV AH,BL
  POP BX
  MOV Buffer,AH
  CALL WriteBuffer
  JC Error_Write
  MOV Buffer,AL
  CALL WriteBuffer
  JC Error_Write
  JMP EncodeNext
SinglePixel:
  POP BX
  INC DX
  INC DI
  TEST AL,192
  JZ SinglePixel1
  MOV Buffer,193
  CALL WriteBuffer
  JC Error_Write
  JMP SinglePixel1
EncodeNext:
  CMP DX,320
  JL EncodeLine
  DEC CX
  JNZ SavePCXloop
  JMP SavePalette
SinglePixel1:
  MOV Buffer,AL
  CALL WriteBuffer
  JC Error_Write
  JMP EncodeNext
SavePalette:
  MOV Buffer,12
  CALL WriteBuffer
  JC Error_Write
  MOV DX,[BP+12]
  MOV DS,DX
  MOV DX,@DATA
  MOV SI,[BP+10]
  MOV CX,768
WritePalette:
  LODSB
  SHL AL,2
  PUSH DS
  MOV DS,DX
  MOV Buffer,AL
  CALL WriteBuffer
  JC Error_Write
  POP DS
  DEC CX
  JNZ WritePalette
  JMP SaveCloseFile
SaveBMP:
  MOV CX,54
  MOV DX,OFFSET BMPheader
  MOV AX,@DATA
  MOV DS,AX
  MOV AH,40h        ; Saves the BMP header
  INT 21h
  JC Error_Write
  MOV SI,[BP+10]    ; DS:SI now points to the palette string
  MOV CX,256
WritePalette1:
  MOV AX,[BP+12]
  MOV DS,AX
  LODSB
  PUSH AX
  LODSB
  PUSH AX
  LODSB
  MOV DX,@DATA
  MOV DS,DX
  SHL AL,2
  MOV Buffer,AL
  CALL WriteBuffer
  JC Error_Write
  POP AX
  SHL AL,2
  MOV Buffer,AL
  CALL WriteBuffer
  JC Error_Write
  POP AX
  SHL AL,2
  MOV Buffer,AL
  CALL WriteBuffer
  JC Error_Write
  MOV Buffer,0
  CALL WriteBuffer
  JC Error_Write
  DEC CX
  JNZ WritePalette1
  MOV CX,200
SaveBMPloop:
  MOV DX,CX
  DEC DX
  MOV SI,DX
  SHL DX,8
  SHL SI,6
  ADD DX,SI
  PUSH CX
  MOV AX,ES
  MOV DS,AX
  MOV AH,40h
  MOV CX,320
  INT 21h
  JC Error_Write
  POP CX
  DEC CX
  JNZ SaveBMPloop
  JMP SaveCloseFile
SaveBSV:
  MOV CX,7
  MOV DX,OFFSET BSVheader
  MOV AX,@DATA
  MOV DS,AX
  MOV AH,40h        ; Saves the BSAVE header
  INT 21h
  JC Error_Write
  MOV CX,64000
  XOR DX,DX
  MOV AX,ES
  MOV DS,AX
  MOV AH,40h        ; Saves the entire layer
  INT 21h
  JC Error_Write
  JMP SaveCloseFile
Error_Create:
  MOV AX,1          ; Error 1: cannot create file
  MOV LastError,9
  JMP EndSaveLayer
Error_Write:
  MOV AH,3Eh
  INT 21h
  MOV AX,2          ; Error 2: cannot write to disk (disk full?)
  MOV LastError,10
  JMP EndSaveLayer
SaveCloseFile:
  MOV AH,3Eh        ; Function 3Eh: close file
  INT 21h
  XOR AX,AX
EndSaveLayer:
  CALL UnhookInt24
  POP BP
  POP DS
  RET 12
xDQBsaveLayer ENDP

; ---------------------------------------------------------------------------
; DQBplayFLI FUNCTION
; purpose:
;   Plays a FLI animation. Supports double-buffering, stop key and looping.
; declaration:
;   DECLARE FUNCTION xDQBplayFLI(BYVAL FileSeg,BYVAL FileOff,BYVAL BufLayer,
;                                BYVAL StopKey,BYVAL Looped)
;   DECLARE FUNCTION DQBplayFLI(FileName AS STRING,BufLayer AS INTEGER,
;                               StopKey AS INTEGER,Looped AS INTEGER)
; ---------------------------------------------------------------------------
PUBLIC xDQBplayFLI
xDQBplayFLI PROC
  ; Stack layout:
  ;
  ; 16  FileSeg
  ; 14  FileOff
  ; 12  BufLayer
  ; 10  StopKey
  ; 08  Looped
  ; 06  Basic return segment
  ; 04  Basic return offset
  ; 02  DS
  ; 00  BP
  PUSH DS
  PUSH BP
  MOV BP,SP
  CMP FLIactive,0
  JE fFileOk
  MOV AX,5
  MOV LastError,21
  POP BP
  POP DS
  RET 10
fFileOk:
  MOV AH,48h
  MOV BX,4096
  INT 21h
  JNC MemOk
  MOV AX,1          ; Error 1: Not enough free base memory
  MOV LastError,7
  POP BP
  POP DS
  RET 10
MemOk:
  MOV FLIbufSeg,AX
  MOV FS,AX
  CALL HookInt24
  MOV BX,[BP+12]
  CALL GetLayerSeg
  MOV ES,CX
  XOR EAX,EAX
  XOR DI,DI
  MOV CX,16000
  REP STOSD  
  MOV AX,[BP+16]
  MOV DS,AX
  MOV DX,[BP+14]
  MOV AX,3D00h
  INT 21h
  JC Error_OpenFLI
  MOV BX,AX
  MOV AX,@DATA
  MOV DS,AX
  MOV FLIfile,BX
  MOV AH,03Fh
  MOV DX,OFFSET FLIheader
  MOV CX,18
  INT 21h
  JC Error_ReadFLI
  CMP FLIheader.hID,0AF11h  ; Check file format
  JNE Error_BadFLI
  CMP FLIheader.Xres,320
  JNE Error_BadFLI
  CMP FLIheader.Yres,200
  JNE Error_BadFLI
  CMP FLIheader.ColorBits,8
  JNE Error_BadFLI
  MOV CX,110
SkipReserved:
  CALL ReadBuffer
  JC Error_ReadFLI
  DEC CX
  JNZ SkipReserved
  MOV FLIframe,0
  MOV FramePos,128
PlayFLIframe:
  CALL DecodeFrame
  JC Error_ReadFLI
  MOV CX,FLIheader.Speed
  MOV DX,3DAh       ; Vertical retrace port
WaitFLI:
  IN AL,DX
  AND AL,8
  JNZ WaitFLI
@@:
  IN AL,DX
  AND AL,8
  JZ @B
  DEC CX
  JNZ WaitFLI
  MOV AX,[BP+12]
  OR AX,AX
  JZ SkipDoubleBuffering
  PUSH ES
  PUSH DS
  MOV BX,ES
  MOV AX,0A000h
  MOV DS,BX
  MOV ES,AX
  MOV CX,16000
  XOR DI,DI
  XOR SI,SI
  REP MOVSD
  POP DS
  POP ES
SkipDoubleBuffering:
  MOV EAX,FLIframeChunk.fSize
  ADD FramePos,EAX
  MOV ECX,FramePos
  MOV DX,CX
  SHR ECX,16
  MOV AX,04200h
  MOV BX,FLIfile
  INT 21h
  JC Error_ReadFLI
  CMP KeyActive,0
  JE CheckLoop
  MOV SI,[BP+10]
  OR SI,SI
  JZ CheckLoop
  CMP SI,0FFFFh
  JNE CheckKey
  XOR SI,SI
@@:
  CMP KeyStatus[SI],1
  JE StopFLI
  INC SI
  CMP SI,128
  JL @B
  JMP CheckLoop
CheckKey:
  CMP KeyStatus[SI],1
  JE StopFLI
CheckLoop:
  INC FLIframe
  MOV AX,FLIheader.frames
  CMP FLIframe,AX
  JL PlayFLIframe
  CMP KeyActive,0
  JE StopFLI
  MOV AX,[BP+10]
  OR AX,AX
  JZ StopFLI
  MOV AX,[BP+8]
  OR AX,AX
  JZ StopFLI
  MOV FLIframe,0
  MOV FramePos,128
  MOV ECX,FramePos
  MOV DX,CX
  SHR ECX,16
  MOV AX,04200h
  MOV BX,FLIfile
  INT 21h
  JC Error_ReadFLI
  JMP PlayFLIframe
StopFLI:
  MOV AH,3Eh
  INT 21h
  MOV AH,49h
  MOV BX,FLIbufSeg
  MOV ES,BX
  INT 21h
  XOR AX,AX
  JMP EndPlayFLI
Error_OpenFLI:
  MOV AH,49h
  MOV BX,FLIbufSeg
  MOV ES,BX
  INT 21h
  MOV AX,2          ; Error 2: Cannot open file (does it exist?)
  MOV LastError,4
  JMP EndPlayFLI
Error_ReadFLI:
  MOV BX,@DATA
  MOV DS,BX
  MOV BX,FLIfile
  MOV AH,3Eh
  INT 21h
  MOV AH,49h
  MOV BX,FLIbufSeg
  MOV ES,BX
  INT 21h
  MOV AX,3          ; Error 3: Unable to read from file
  MOV LastError,5
  JMP EndPlayFLI
Error_BadFLI:
  MOV BX,FLIfile
  MOV AH,3Eh
  INT 21h
  MOV AH,49h
  MOV BX,FLIbufSeg
  MOV ES,BX
  INT 21h
  MOV AX,4          ; Error 4: Bad FLI file
  MOV LastError,11
EndPlayFLI:
  CALL UnhookInt24
  POP BP
  POP DS
  RET 10
xDQBplayFLI ENDP

; ---------------------------------------------------------------------------
; DQBopenFLI FUNCTION
; purpose:
;   Opens a FLI file and resets internal variables. Also returns number of
;   frames and speed
; declaration:
;   DECLARE FUNCTION xDQBopenFLI(BYVAL FileSeg,BYVAL FileOff,Frames,Speed)
;   DECLARE FUNCTION DQBopenFLI(FileName AS STRING,Frames AS INTEGER,
;                               Speed AS INTEGER)
; ---------------------------------------------------------------------------
PUBLIC xDQBopenFLI
xDQBopenFLI PROC
  ; Stack layout:
  ;
  ; 14  FileSeg
  ; 12  FileOff
  ; 10  Frames
  ; 08  Speed
  ; 06  Basic return segment
  ; 04  Basic return offset
  ; 02  DS
  ; 00  BP
  PUSH DS
  PUSH BP
  MOV BP,SP
  CMP FLIactive,0
  JNE Error_AlreadyOpened
  MOV AH,48h
  MOV BX,4096
  INT 21h
  JC Error_NotEnoughMem
  MOV FLIbufSeg,AX
  MOV FS,AX
  CALL HookInt24
  MOV AX,[BP+14]
  MOV DS,AX
  MOV DX,[BP+12]
  MOV AX,3D00h
  INT 21h
  JC Error_OpenOpenFLI
  MOV BX,AX
  MOV AX,@DATA
  MOV DS,AX
  MOV FLIfile,BX
  MOV AH,03Fh
  MOV DX,OFFSET FLIheader
  MOV CX,18
  INT 21h
  JC Error_OpenReadFLI
  CMP FLIheader.hID,0AF11h  ; Check file format
  JNE Error_OpenBadFLI
  CMP FLIheader.Xres,320
  JNE Error_OpenBadFLI
  CMP FLIheader.Yres,200
  JNE Error_OpenBadFLI
  CMP FLIheader.ColorBits,8
  JNE Error_OpenBadFLI
  MOV CX,110
@@:
  CALL ReadBuffer
  JC Error_OpenReadFLI
  DEC CX
  JNZ @B
  MOV FLIframe,0
  MOV FramePos,128
  MOV SI,[BP+10]
  MOV AX,FLIheader.Frames
  MOV [SI],AX
  MOV SI,[BP+8]
  MOV AX,FLIheader.Speed
  MOV [SI],AX
  MOV FLIactive,1
  XOR AX,AX
  JMP EndOpenFLI
Error_NotEnoughMem:
  MOV AX,1          ; Error 1: Not enough free base memory
  MOV LastError,7
  POP BP
  POP DS
  RET 8
Error_OpenOpenFLI:
  MOV AH,49h
  MOV BX,FLIbufSeg
  MOV ES,BX
  INT 21h
  MOV AX,2          ; Error 2: Cannot open file (does it exist?)
  MOV LastError,4
  JMP EndOpenFLI
Error_OpenReadFLI:
  MOV BX,@DATA
  MOV DS,BX
  MOV BX,FLIfile
  MOV AH,3Eh
  INT 21h
  MOV AH,49h
  MOV BX,FLIbufSeg
  MOV ES,BX
  INT 21h
  MOV AX,3          ; Error 3: Unable to read from file
  MOV LastError,5
  JMP EndOpenFLI
Error_OpenBadFLI:
  MOV BX,FLIfile
  MOV AH,3Eh
  INT 21h
  MOV AH,49h
  MOV BX,FLIbufSeg
  MOV ES,BX
  INT 21h
  MOV AX,4          ; Error 4: Bad FLI file
  MOV LastError,11
  JMP EndOpenFLI
Error_AlreadyOpened:
  MOV AX,5          ; Error 5: A FLI file has already been opened
  MOV LastError,21
  POP BP
  POP DS
  RET 8
EndOpenFLI:
  CALL UnhookInt24
  POP BP
  POP DS
  RET 8
xDQBopenFLI ENDP

; ---------------------------------------------------------------------------
; DQBcloseFLI SUB
; purpose:
;   Closes an opened FLI file
; declaration:
;   DECLARE SUB DQBcloseFLI()
; ---------------------------------------------------------------------------
PUBLIC DQBcloseFLI
DQBcloseFLI PROC
  CMP FLIactive,0
  JE EndCloseFLI
  MOV BX,FLIfile
  MOV AH,3Eh
  INT 21h
  MOV AH,49h
  MOV BX,FLIbufSeg
  MOV ES,BX
  INT 21h
  MOV FLIactive,0
EndCloseFLI:
  RET
DQBcloseFLI ENDP

; ---------------------------------------------------------------------------
; DQBplayFLIstep SUB
; purpose:
;   Decodes the next frame of an opened FLI file into a specified layer. If
;   there are no more frames left, the animation automatically restarts from
;   the first one. On errors, this function does nothing.
; declaration:
;   DECLARE SUB DQBplayFLIstep(BYVAL Layer)
; ---------------------------------------------------------------------------
PUBLIC DQBplayFLIstep
DQBplayFLIstep PROC
  PUSH DS
  PUSH BP
  MOV BP,SP
  CALL HookInt24
  CMP FLIactive,0
  JE EndPlayFLIstep
  MOV BX,[BP+8]
  CALL GetLayerSeg
  MOV ES,CX
  MOV AX,FLIbufSeg
  MOV FS,AX
  CALL DecodeFrame
  JC EndPlayFLIstep
  MOV EAX,FLIframeChunk.fSize
  ADD FramePos,EAX
  MOV ECX,FramePos
  MOV DX,CX
  SHR ECX,16
  MOV AX,04200h
  MOV BX,FLIfile
  INT 21h
  JC EndPlayFLIstep
  INC FLIframe
  MOV AX,FLIheader.frames
  CMP FLIframe,AX
  JL EndPlayFLIstep
  MOV FLIframe,0
  MOV FramePos,128
  MOV ECX,FramePos
  MOV DX,CX
  SHR ECX,16
  MOV AX,04200h
  MOV BX,FLIfile
  INT 21h
EndPlayFLIstep:
  CALL UnHookInt24
  POP BP
  POP DS
  RET 2
DQBplayFLIstep ENDP

END
